import java.util.*;
public class Machine {
    private final String plainText;
    private final ArrayList<Character> beforeEncrypt = new ArrayList<>();
    private final ArrayList<Character> plugboardForward = new ArrayList<>();
    private final ArrayList<Character> firstEncryptForward = new ArrayList<>();
    private final ArrayList<Character> secondEncryptForward = new ArrayList<>();
    private final ArrayList<Character> thirdEncryptForward = new ArrayList<>();
    private final ArrayList<Character> firstEncryptBackward = new ArrayList<>();
    private final ArrayList<Character> secondEncryptBackward = new ArrayList<>();
    private final ArrayList<Character> thirdEncryptBackward = new ArrayList<>();
    private final ArrayList<Character> plugboardBackward = new ArrayList<>();
    private final ArrayList<Character> reflectorEncrypt = new ArrayList<>();
    private final Rotor firstRotor;
    private final Rotor secondRotor;
    private final Rotor thirdRotor;
    private final Reflector refl;
    private final Plugboard plugB;

    public Machine(String inputText, Rotor rotorOne, Rotor rotorTwo, Rotor rotorThree, Reflector reflect, Plugboard pluggy){
        this.plainText = inputText.toUpperCase();
        this.firstRotor = rotorOne;
        this.secondRotor = rotorTwo;
        this.thirdRotor = rotorThree;
        this.refl = reflect;
        this.plugB = pluggy;
    }
    public char encryptForward(HashMap<Character,Character> mapping, char letter){
        return mapping.get(letter);
    }
    public char encryptBack(HashMap<Character,Character> mapping, char letter){
        for(char i : mapping.keySet()){
            if(letter == mapping.get(i)){
                return i;
            }
        }
        return 'a';
    }
    public String encryptMessage() {
        if (!plugB.validatePlugboard()) {
            return "PLUGBOARD ERROR";
        } else {
            char[] plainArray = this.plainText.toCharArray();
            String outputText = "";
            char plugEnc, firstRotorEnc, secondRotorEnc, thirdRotorEnc, reflEnc, firstBackEnc, secondBackEnc, thirdBackEnc, plugBackEnc;
            for (char c : plainArray) {
                if (c > 64 && c < 91) {
                    if (firstRotor.turnoverCheck()) {

                        if (secondRotor.turnoverCheck()) {
                            thirdRotor.rotateRotor();
                            thirdRotor.increasePosition();
                        }
                        secondRotor.rotateRotor();
                        secondRotor.increasePosition();
                    }
                    System.out.println("--------------------------------------");
                    firstRotor.rotateRotor();
                    firstRotor.increasePosition();
                    this.beforeEncrypt.add(c);
                    System.out.println("Initial Letter: " + c);

                    plugEnc = encryptForward(plugB.getMapping(), c);
                    this.plugboardForward.add(plugEnc);
                    System.out.println("Plugboard: " + plugEnc);

                    firstRotorEnc = encryptForward(firstRotor.getMapping(), plugEnc);
                    this.firstEncryptForward.add(firstRotorEnc);
                    System.out.println("Rotor 1: " + firstRotorEnc);

                    secondRotorEnc = encryptForward(secondRotor.getMapping(), firstRotorEnc);
                    this.secondEncryptForward.add(secondRotorEnc);
                    System.out.println("Rotor 2: " + secondRotorEnc);

                    thirdRotorEnc = encryptForward(thirdRotor.getMapping(), secondRotorEnc);
                    this.thirdEncryptForward.add(thirdRotorEnc);
                    System.out.println("Rotor 3: " + thirdRotorEnc);

                    reflEnc = encryptForward(refl.getMapping(), thirdRotorEnc);
                    this.reflectorEncrypt.add(reflEnc);
                    System.out.println("Reflector: " + reflEnc);

                    thirdBackEnc = encryptBack(thirdRotor.getMapping(), reflEnc);
                    this.thirdEncryptBackward.add(thirdBackEnc);
                    System.out.println("Rotor 3: " + thirdBackEnc);

                    secondBackEnc = encryptBack(secondRotor.getMapping(), thirdBackEnc);
                    this.secondEncryptBackward.add(secondBackEnc);
                    System.out.println("Rotor 2: " + secondBackEnc);

                    firstBackEnc = encryptBack(firstRotor.getMapping(), secondBackEnc);
                    this.firstEncryptBackward.add(firstBackEnc);
                    System.out.println("Rotor 1: " + firstBackEnc);

                    plugBackEnc = encryptBack(plugB.getMapping(), firstBackEnc);
                    this.plugboardBackward.add(plugBackEnc);
                    System.out.println("Plugboard: " + plugBackEnc);
                    System.out.println("--------------------------------------");

                    outputText = outputText + plugBackEnc;
                } else {
                    outputText = outputText + c;
                }
            }
            return outputText;
        }
    }
        public char[] getEncryptionIndex(int index){
        char[] indexes = new char[10];
            indexes[0] = beforeEncrypt.get(index);
            indexes[1] = plugboardForward.get(index);
            indexes[2] = firstEncryptForward.get(index);
            indexes[3] = secondEncryptForward.get(index);
            indexes[4] = thirdEncryptForward.get(index);
            indexes[5] = reflectorEncrypt.get(index);
            indexes[6] = thirdEncryptBackward.get(index);
            indexes[7] = secondEncryptBackward.get(index);
            indexes[8] = firstEncryptBackward.get(index);
            indexes[9] = plugboardBackward.get(index);
        return indexes;
        }
    }


