import java.util.HashMap;

public class Plugboard{
    private String pairings;
    private final HashMap<Character,Character> mapping;

    public Plugboard(String startPairs){
        this.pairings = startPairs;
        this.mapping = createPlugBoard();
    }

    public HashMap<Character, Character> getMapping() {
        return mapping;
    }

    public HashMap<Character,Character> oldcreatePlugBoard(){
        if(!validatePlugboard()){
            char[] alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ".toCharArray();
            HashMap<Character, Character> plugMapping = new HashMap<>();
            for (int n = 0; n < alphabet.length; n++) {
                plugMapping.put(alphabet[n], alphabet[n]);
            }
            return plugMapping;
        }
        else {
            String[] split = this.pairings.split("\\s+");
            char[] alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ".toCharArray();
            char[] plugboard = alphabet.clone();
            for (String s : split) {
                char in = s.charAt(0); //Example 'A'
                char out = s.charAt(1); //Example 'T'
                int inPos = (int) in - 65; //1st letter of the alphabet, index 0
                int outPos = (int) out - 65; //20th letter of the alphabet, index 19
                plugboard[inPos] = out; //Set index 0 (A spot) to be swapped with T
                plugboard[outPos] = in; //Set index 19 (T spot) to be swapped with A
            }
            HashMap<Character, Character> plugMapping = new HashMap<>();
            for (int n = 0; n < alphabet.length; n++) {
                plugMapping.put(alphabet[n], plugboard[n]);
            }
            return plugMapping;
        }
    }

    public HashMap<Character,Character> createPlugBoard() {
        char[] alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ".toCharArray();
        char[] plugboard = alphabet.clone();
        HashMap<Character, Character> plugMapping = new HashMap<>();
        for (int n = 0; n < alphabet.length; n++) {
            plugMapping.put(alphabet[n], alphabet[n]);
        }
        if(!pairings.endsWith(" ") && !pairings.equals("")){
            pairings = pairings + " ";
        }
        if(pairings.equals("") || pairings.length() % 3 != 0){
            return plugMapping;
        }
        String[] split = this.pairings.split("\\s+");
        for (String s : split) {
            char in = s.charAt(0); //Example 'A'
            char out = s.charAt(1); //Example 'T'
            int inPos = (int) in - 65; //1st letter of the alphabet, index 0
            int outPos = (int) out - 65; //20th letter of the alphabet, index 19
            plugboard[inPos] = out; //Set index 0 (A spot) to be swapped with T
            plugboard[outPos] = in; //Set index 19 (T spot) to be swapped with A
        }
        for (int n = 0; n < alphabet.length; n++) {
            plugMapping.put(alphabet[n], plugboard[n]);
        }
        return plugMapping;
    }
    public boolean validatePlugboard(){
        if(pairings.length() % 3 != 0){
            return false;
        }
        return true;
    }


}
