import java.util.HashMap;
public class Rotor{
private final String type;
private int position;
private final char[] turnover;
private HashMap<Character,Character> mapping;

public Rotor(String startType, int startPos){
    this.type = startType;
    this.position = startPos;
    this.turnover = turnoverSelection();
    this.mapping = createMapping();
    for (int i = 0; i < this.position; i++){
        rotateRotor();
    }
}
    public HashMap<Character, Character> getMapping() {
        return mapping;
    }

    public char[] rotorSelection(){
        return switch (this.type) {
            case "I"   -> "EKMFLGDQVZNTOWYHXUSPAIBRCJ".toCharArray();
            case "II"  -> "AJDKSIRUXBLHWTMCQGZNPYFVOE".toCharArray();
            case "III" -> "BDFHJLCPRTXVZNYEIWGAKMUSQO".toCharArray();
            case "IV"  -> "ESOVPZJAYQUIRHXLNFTGKDCMWB".toCharArray();
            case "V"   -> "VZBRGITYUPSDNHLXAWMJQOFECK".toCharArray();
            case "VI"  -> "JPGVOUMFYQBENHZRDKASXLICTW".toCharArray();
            case "VII" -> "NZJHGRCXMYSWBOUFAIVLPEKQDT".toCharArray();
            default    -> "FKQHTLXOCBJSPDZRAMEWNIUYGV".toCharArray();
        };
    }
    public void rotateRotor(){
        HashMap<Character, Character> newMapping = new HashMap<>();
        for(Character i : this.mapping.keySet()){
            char key = (char) (i - 1);
            if(key < 65){
                key = (char) (key + 26);
            }
            char value = (char) (this.mapping.get(i) - 1);
            if(value < 65){
                value = (char) (value + 26);
            }
            newMapping.put(key,value);
        }
        this.mapping = newMapping;
    }
    public HashMap<Character,Character> createMapping(){
        char[] input = "ABCDEFGHIJKLMNOPQRSTUVWXYZ".toCharArray();
        char[] output = rotorSelection();
        HashMap<Character, Character> rotorMapping = new HashMap<>();
        for(int n =0; n < input.length;n++) {
            rotorMapping.put(input[n],output[n]);
        }
        return rotorMapping;
    }
    public void increasePosition(){
    this.position++;
    if(this.position > 25){
        this.position = 0;
    }

    }
    public char[] turnoverSelection(){
        return switch (this.type) {
            case "I" -> new char[]{'Q'};
            case "II" -> new char[]{'E'};
            case "III" -> new char[]{'V'};
            case "IV" -> new char[]{'J'};
            case "V" -> new char[]{'Z'};
            default  -> new char[]{'M', 'Z'};
        };
    }
    public boolean turnoverCheck(){
        char pos = (char) (this.position + 65);
        for (char c : this.turnover) {
            if (pos == c) {
                return true;
            }
        }
        return false;
    }
}
