import javax.swing.*;
import javax.swing.text.*;
import java.awt.*;
import java.util.Arrays;

public class ViewPlugboard {
    private final JFrame plugFrame = new JFrame("Plugboard Settings");
    private final JLabel labelInput = new JLabel("Existing Swaps: ");
    private final JLabel labelInstruction1 = new JLabel("1) Press the buttons on screen to pair letter. Press same letter again to unpair.");
    private final JLabel labelInstruction2 = new JLabel("Or 2) Type into the text box to pair. Example formatting to pair A+B and C+D is 'AB CD'.");
    private final JLabel labelValid = new JLabel();
    private final JTextField textPairs = new JTextField();
    private final JButton buttonBack = new JButton("Return");
    private final JButton buttonInstruct = new JButton("Instructions");
    private final JButton buttonInfo = new JButton("Background Info");
    private final JTextArea textAPairings= new JTextArea();
    private final JButton buttonQ = new JButton("Q");
    private final JButton buttonW = new JButton("W");
    private final JButton buttonE = new JButton("E");
    private final JButton buttonR = new JButton("R");
    private final JButton buttonT = new JButton("T");
    private final JButton buttonZ = new JButton("Z");
    private final JButton buttonU = new JButton("U");
    private final JButton buttonI = new JButton("I");
    private final JButton buttonO = new JButton("O");
    private final JButton buttonA = new JButton("A");
    private final JButton buttonS = new JButton("S");
    private final JButton buttonD = new JButton("D");
    private final JButton buttonF = new JButton("F");
    private final JButton buttonG = new JButton("G");
    private final JButton buttonH = new JButton("H");
    private final JButton buttonJ = new JButton("J");
    private final JButton buttonK = new JButton("K");
    private final JButton buttonP = new JButton("P");
    private final JButton buttonY = new JButton("Y");
    private final JButton buttonX = new JButton("X");
    private final JButton buttonC = new JButton("C");
    private final JButton buttonV = new JButton("V");
    private final JButton buttonB = new JButton("B");
    private final JButton buttonN = new JButton("N");
    private final JButton buttonM = new JButton("M");
    private final JButton buttonL = new JButton("L");
    StyleContext styleCon = new StyleContext();
    DefaultStyledDocument doc = new DefaultStyledDocument(styleCon);
    JTextPane txtStyledPairs = new JTextPane(doc);
    final Style errorStyle = styleCon.addStyle("ERROR", null);
    final Style normalStyle = styleCon.addStyle("NORMAL",null);


    public void setupPlugSettings(){
        plugFrame.setDefaultCloseOperation(plugFrame.EXIT_ON_CLOSE);
        labelInput.setBounds(10,20,150,25);
        plugFrame.add(labelInput);
        textPairs.setBounds(150,250,450,25);
        plugFrame.add(textPairs);
        labelInstruction1.setBounds(150,10,500,40);
        plugFrame.add(labelInstruction1);
        labelInstruction2.setBounds(150,200,500,50);
        plugFrame.add(labelInstruction2);
        buttonBack.setBounds(300,300,150,25);
        plugFrame.add(buttonBack);
        textAPairings.setBounds(10,50,100,225);
        plugFrame.add(textAPairings);
        labelValid.setBounds(475,300,150,20);
        plugFrame.add(labelValid);
        buttonQ.setBounds(150,50,45,45);
        plugFrame.add(buttonQ);
        buttonW.setBounds(200,50,45,45);
        plugFrame.add(buttonW);
        buttonE.setBounds(250,50,45,45);
        plugFrame.add(buttonE);
        buttonR.setBounds(300,50,45,45);
        plugFrame.add(buttonR);
        buttonT.setBounds(350,50,45,45);
        plugFrame.add(buttonT);
        buttonZ.setBounds(400,50,45,45);
        plugFrame.add(buttonZ);
        buttonU.setBounds(450,50,45,45);
        plugFrame.add(buttonU);
        buttonI.setBounds(500,50,45,45);
        plugFrame.add(buttonI);
        buttonO.setBounds(550,50,45,45);
        plugFrame.add(buttonO);
        buttonA.setBounds(175,100,45,45);
        plugFrame.add(buttonA);
        buttonS.setBounds(225,100,45,45);
        plugFrame.add(buttonS);
        buttonD.setBounds(275,100,45,45);
        plugFrame.add(buttonD);
        buttonF.setBounds(325,100,45,45);
        plugFrame.add(buttonF);
        buttonG.setBounds(375,100,45,45);
        plugFrame.add(buttonG);
        buttonH.setBounds(425,100,45,45);
        plugFrame.add(buttonH);
        buttonJ.setBounds(475,100,45,45);
        plugFrame.add(buttonJ);
        buttonK.setBounds(525,100,45,45);
        plugFrame.add(buttonK);
        buttonP.setBounds(150,150,45,45);
        plugFrame.add(buttonP);
        buttonY.setBounds(200,150,45,45);
        plugFrame.add(buttonY);
        buttonX.setBounds(250,150,45,45);
        plugFrame.add(buttonX);
        buttonC.setBounds(300,150,45,45);
        plugFrame.add(buttonC);
        buttonV.setBounds(350,150,45,45);
        plugFrame.add(buttonV);
        buttonB.setBounds(400,150,45,45);
        plugFrame.add(buttonB);
        buttonN.setBounds(450,150,45,45);
        plugFrame.add(buttonN);
        buttonM.setBounds(500,150,45,45);
        plugFrame.add(buttonM);
        buttonL.setBounds(550,150,45,45);
        plugFrame.add(buttonL);
        buttonInstruct.setBounds(125,300,150,25);
        plugFrame.add(buttonInstruct);
        buttonInfo.setBounds(475,300,150,25);
        plugFrame.add(buttonInfo);

        txtStyledPairs.setBounds(200,350,250,100);
        plugFrame.add(txtStyledPairs);
        txtStyledPairs.setEditable(false);
        
        errorStyle.addAttribute(StyleConstants.Foreground, new Color(220,38,127));
        errorStyle.addAttribute(StyleConstants.FontSize, 14);
        errorStyle.addAttribute(StyleConstants.Bold, true);

        normalStyle.addAttribute(StyleConstants.Foreground, new Color(0,0,0));
        normalStyle.addAttribute(StyleConstants.FontSize, 14);
        normalStyle.addAttribute(StyleConstants.Bold, false);

        //plugFrame.setSize(700, 500);
        plugFrame.setSize(1000,1000);
        plugFrame.setLayout(null);
        plugFrame.setVisible(false);
        textAPairings.setEditable(false);
    }

    public JButton getButtonBack() {
        return buttonBack;
    }
    public JButton getButtonA() {return buttonA;}
    public JButton getButtonB() {return buttonB;}
    public JButton getButtonC() {return buttonC;}
    public JButton getButtonD() {return buttonD;}
    public JButton getButtonE() {return buttonE;}
    public JButton getButtonF() {return buttonF;}
    public JButton getButtonG() {return buttonG;}
    public JButton getButtonH() {return buttonH;}
    public JButton getButtonI() {return buttonI;}
    public JButton getButtonJ() {return buttonJ;}
    public JButton getButtonK() {return buttonK;}
    public JButton getButtonL() {return buttonL;}
    public JButton getButtonM() {return buttonM;}
    public JButton getButtonN() {return buttonN;}
    public JButton getButtonO() {return buttonO;}
    public JButton getButtonP() {return buttonP;}
    public JButton getButtonQ() {return buttonQ;}
    public JButton getButtonR() {return buttonR;}
    public JButton getButtonS() {return buttonS;}
    public JButton getButtonT() {return buttonT;}
    public JButton getButtonU() {return buttonU;}
    public JButton getButtonV() {return buttonV;}
    public JButton getButtonW() {return buttonW;}
    public JButton getButtonX() {return buttonX;}
    public JButton getButtonY() {return buttonY;}
    public JButton getButtonZ() {return buttonZ;}
    public JButton getButtonInstruct(){return buttonInstruct;}
    public JButton getButtonInfo(){return buttonInfo;}
    public JFrame getplugFrame() {
        return plugFrame;
    }
    public String getTextPairsText() {
        return textPairs.getText();
    }
    public JTextField getTextPairs(){
        return textPairs;
    }
    public void setTextPairs(String msg){textPairs.setText(msg);}
    public void setWarningText(String msg){
        labelValid.setText(msg);
    }
    public void updatePairField(String msg) throws BadLocationException {
        String formattedMsg = "";
        for (int n = 0; n < msg.length(); n++){
            if(n % 3 == 0){
                formattedMsg = formattedMsg + msg.charAt(n) + " <---> ";
            }
            if(n % 3 == 1){
                formattedMsg = formattedMsg + msg.charAt(n) + "\n";
            }
        }
        textAPairings.setText(formattedMsg);
        doc.insertString(0, formattedMsg, errorStyle);
    }

    public boolean validatePairs(){
        String pairs = textPairs.getText().toUpperCase();
        char[] letters = pairs.toCharArray();
        String spaceless = pairs.replace(" ", "");
        char[] dupCheck = spaceless.toCharArray();
        Arrays.sort(dupCheck);
        for (int n = 0; n < pairs.length(); n++){
            if(n % 3 == 2){
                if(letters[n] != ' '){
                    return false;
                }
            }
            else{
                if(letters[n] == ' '){
                    return false;
                }
                if(!(letters[n] >= 'A' && letters[n] <= 'Z')){
                    return false;
                }

            }
        }
        for(int i = 1; i < dupCheck.length; i++){
            if(dupCheck[i] == dupCheck[i-1]){
                return false;
            }
        }
        return true;
    }

    public void updateWarning(){
        if(validatePairs()){
            setWarningText("VALID CONFIG");

        }
        else{
            setWarningText("INVALID CONFIG");
        }
    }
    public void plugboardInstructions() throws BadLocationException {
        JDialog dia = new JDialog(plugFrame,"Plugboard Instructions");
        StyleContext con = new StyleContext();
        DefaultStyledDocument doc = new DefaultStyledDocument(con);
        Style defaultStyle = con.addStyle("Default",null);
        JTextPane textInstructions = new JTextPane(doc);
        textInstructions.setEditable(false);
        dia.add(textInstructions);
        dia.setSize(500,350);
        dia.setVisible(true);
        defaultStyle.addAttribute(StyleConstants.Foreground, new Color(0,0,0));
        defaultStyle.addAttribute(StyleConstants.FontSize, 14);
        defaultStyle.addAttribute(StyleConstants.Family,"Helvetica");
        String msg = """
                You can use either option on the GUI to configure the plugboard.
                To use option one, simply click two buttons and they will be paired together.
                The text box of the left of the GUI will show you the currently paired letters.
                As a letter cannot be paired more than once, if you select a letter that is already been paired,
                then it will delete the pair the selected letter was a part of.

                To use option two, type the letters you want to pair together followed by a space.
                If you wish to pair A<->B, C<->D AND E<->F then type: AB CD EF

                If you have entered a duplicate letter using option 2 or have an incomplete pairing then you will get an error message as your output.
                If your pairing is invalid a small red cross will appear near the bottom right of the screen, otherwise you will get a green tick if it is valid.
                """;
        doc.insertString(0,msg,defaultStyle);
        textInstructions.setBounds(5,20,450,300);
    }
    public void plugboardInfo() throws BadLocationException {
        JDialog dia = new JDialog(plugFrame,"Background Info");
        StyleContext con = new StyleContext();
        DefaultStyledDocument doc = new DefaultStyledDocument(con);
        Style defaultStyle = con.addStyle("Default",null);
        JTextPane textInstructions = new JTextPane(doc);
        textInstructions.setEditable(false);
        dia.add(textInstructions);
        dia.setSize(400,200);
        dia.setVisible(true);
        defaultStyle.addAttribute(StyleConstants.Foreground, new Color(0,0,0));
        defaultStyle.addAttribute(StyleConstants.FontSize, 14);
        defaultStyle.addAttribute(StyleConstants.Family,"Helvetica");
        String msg = "The buttons on the GUI are in the same order as a plugboard. " +
                "The plugboard was configured by the user physically plugging a connection between two letters, this " +
                "would cause them to substitute for each other between the keyboard and the outside of the first rotor.";
        doc.insertString(0,msg,defaultStyle);
        textInstructions.setBounds(5,20,350,150);
    }

}
