import javax.swing.*;
import javax.swing.text.*;
import java.awt.*;

public class ViewReflector {
    private final JFrame reflectorFrame = new JFrame("Reflector Settings");
    private final JLabel labelInput = new JLabel("Select Reflector Type: ");
    private final JButton buttonBack = new JButton("Return");
    private final JButton buttonInstruct = new JButton("Instructions");
    private final JButton buttonInfo = new JButton("Background Info");
    private final JLabel labelInstruct = new JLabel("Click on the dropdown box to select the reflector type you want to use.");
    private final JLabel labelImage = new JLabel();
    private final JComboBox comboBoxReflector = new JComboBox(new String[]{"UKW-B", "UKW-C"});
    private final String directory = System.getProperty("user.dir");
    ImageIcon reflBIcon = new ImageIcon(directory + "\\Image Dump\\Reflector B.png");
    ImageIcon reflCIcon = new ImageIcon(directory + "\\Image Dump\\Reflector C.png");

    public void setupReflectorSettings(){
        reflectorFrame.setDefaultCloseOperation(reflectorFrame.EXIT_ON_CLOSE);
        labelInput.setBounds(10,50,150,25);
        reflectorFrame.add(labelInput);
        labelInstruct.setBounds(10,25,450,25);
        reflectorFrame.add(labelInstruct);
        buttonInstruct.setBounds(5,610,150,25);
        reflectorFrame.add(buttonInstruct);
        buttonBack.setBounds(356,610,150,25);
        reflectorFrame.add(buttonBack);
        buttonInfo.setBounds(180,610,150,25);
        reflectorFrame.add(buttonInfo);
        comboBoxReflector.setBounds(175,50,150,25);
        labelImage.setBounds(5,100,500,500);
        labelImage.setIcon(reflBIcon);
        reflectorFrame.add(labelImage);
        reflectorFrame.add(comboBoxReflector);
        reflectorFrame.setSize(525, 750);
        reflectorFrame.setLayout(null);
        reflectorFrame.setVisible(false);
    }

    public JButton getButtonBack() {
        return buttonBack;
    }
    public JButton getButtonInstruct() {
        return buttonInstruct;
    }
    public JButton getButtonInfo() {
        return buttonInfo;
    }
    public JFrame getReflectorFrame() {
        return reflectorFrame;
    }

    public JComboBox getComboBoxReflector() {
        return comboBoxReflector;
    }

    public String getReflectorType(){
        return (String) comboBoxReflector.getSelectedItem();
    }
    public void setReflIcon(int comboIndex){
        if(comboIndex == 0){
            labelImage.setIcon(reflBIcon);
        }
        else{
            labelImage.setIcon(reflCIcon);
        }
    }
    public void reflectorInstructions(){
        JDialog dia = new JDialog(reflectorFrame,"Reflector Instructions");
        JLabel textInstructions = new JLabel("The reflector is the final component, it is structured with an outside ring of letters " +
                "and internal wires connecting them in pairs which do not change throughout the process, the image above shows the connections inside of a reflector. " +
                "The reflector does not rotate and does a symmetrical substitution, similar to the plugboard, " +
                "before sending the signal back through all of the components in the reverse order.");
        dia.add(textInstructions);
        dia.setSize(200,200);
        dia.setVisible(true);
    }
    public void reflectorInfo() throws BadLocationException {
        JDialog dia = new JDialog(reflectorFrame,"Background Info");
        StyleContext con = new StyleContext();
        DefaultStyledDocument doc = new DefaultStyledDocument(con);
        Style defaultStyle = con.addStyle("Default",null);
        JTextPane textInstructions = new JTextPane(doc);
        textInstructions.setEditable(false);
        dia.add(textInstructions);
        dia.setSize(400,200);
        dia.setVisible(true);
        defaultStyle.addAttribute(StyleConstants.Foreground, new Color(0,0,0));
        defaultStyle.addAttribute(StyleConstants.FontSize, 14);
        defaultStyle.addAttribute(StyleConstants.Family,"Helvetica");
        String msg = "The reflector is the final component, it is structured with an outside ring of letters " +
                "and internal wires connecting them in pairs which do not change throughout the process, the image above shows the connections inside of a reflector. " +
                "The reflector does not rotate and does a symmetrical substitution, similar to the plugboard, " +
                "before sending the signal back through all of the components in the reverse order.";
        doc.insertString(0,msg,defaultStyle);
        textInstructions.setBounds(5,20,350,150);
    }
}
