import javax.swing.*;
import javax.swing.text.*;
import java.awt.*;
import java.util.Hashtable;

public class ViewRotor {
    private final JFrame rotorFrame = new JFrame("Rotor Settings");
    private final JLabel labelInput = new JLabel("Input Text: ");
    private final JLabel labelPos = new JLabel("Rotor Starting Position");
    private final JLabel labelTurn = new JLabel("Turnover Position: ");
    private final JLabel labelComboInstruct = new JLabel("Click on the dropdown box to select the Rotor Type you want to use.");
    private final JLabel labelSliderInstruct = new JLabel("Adjust the slider to change the starting position of the rotor");
    private final JLabel labelImage = new JLabel();
    private final JTextField textTurnover= new JTextField();
    private final JButton buttonBack = new JButton("Return");
    private final JButton buttonInfo = new JButton("Background Info");
    private final String[] rotorTypes = {"I", "II", "III", "IV", "V", "VI","VII","VIII"};
    private final JComboBox comboBoxRotorType = new JComboBox(rotorTypes);
    private final JSlider positionSlider = new JSlider(JSlider.HORIZONTAL,0,25,0);
    private final String directory = System.getProperty("user.dir");
    ImageIcon rotor1Icon = new ImageIcon(directory + "\\Image Dump\\Rotor Type 1.png");
    ImageIcon rotor2Icon = new ImageIcon(directory + "\\Image Dump\\Rotor Type 2.png");
    ImageIcon rotor3Icon = new ImageIcon(directory + "\\Image Dump\\Rotor Type 3.png");
    ImageIcon rotor4Icon = new ImageIcon(directory + "\\Image Dump\\Rotor Type 4.png");
    ImageIcon rotor5Icon = new ImageIcon(directory + "\\Image Dump\\Rotor Type 5.png");
    ImageIcon rotor6Icon = new ImageIcon(directory + "\\Image Dump\\Rotor Type 6.png");
    ImageIcon rotor7Icon = new ImageIcon(directory + "\\Image Dump\\Rotor Type 7.png");
    ImageIcon rotor8Icon = new ImageIcon(directory + "\\Image Dump\\Rotor Type 8.png");
    public void setupRotorSettings(){
        rotorFrame.setDefaultCloseOperation(rotorFrame.EXIT_ON_CLOSE);
        labelComboInstruct.setBounds(40,20,450,25);
        rotorFrame.add(labelComboInstruct);
        labelSliderInstruct.setBounds(40,110,450,25);
        rotorFrame.add(labelSliderInstruct);
        labelInput.setBounds(40,50,150,25);
        rotorFrame.add(labelInput);
        labelPos.setBounds(185,85,150,25);
        rotorFrame.add(labelPos);
        labelTurn.setBounds(310,50,150,25);
        rotorFrame.add(labelTurn);
        textTurnover.setBounds(425,50,40,25);
        textTurnover.setEditable(false);
        textTurnover.setText("Q");
        rotorFrame.add(textTurnover);
        comboBoxRotorType.setBounds(95,50,150,25);
        rotorFrame.add(comboBoxRotorType);
        buttonBack.setBounds(356,710,150,25);
        rotorFrame.add(buttonBack);
        buttonInfo.setBounds(180,710,150,25);
        rotorFrame.add(buttonInfo);
        positionSlider.setBounds(30,140,450,50);
        positionSlider.setMajorTickSpacing(5);
        positionSlider.setMinorTickSpacing(1);
        positionSlider.setPaintTicks(true);
        Hashtable labelTable = new Hashtable();
        char[] labels = "ABCDEFGHIJKLMNOPQRSTUVWXYZ".toCharArray();
        for(int n = 0; n < 26; n++){
            labelTable.put(n,new JLabel(String.valueOf(labels[n])));
        }
        positionSlider.setLabelTable(labelTable);
        positionSlider.setPaintLabels(true);
        rotorFrame.add(positionSlider);
        labelImage.setBounds(5,200,500,500);
        ImageIcon defaultIcon = new ImageIcon(directory + "\\Image Dump\\Rotor Type 1.png");
        labelImage.setIcon(defaultIcon);
        rotorFrame.add(labelImage);
        rotorFrame.setSize(525, 800);
        rotorFrame.setLayout(null);
        rotorFrame.setVisible(false);
    }

    public JButton getButtonBack() {
        return buttonBack;
    }
    public JButton getButtonInfo(){return buttonInfo;}
    public JFrame getRotorFrame() {
        return rotorFrame;
    }
    public void setLabelInputText(String message){
        labelInput.setText(message);
    }
    public String getRotorType(){
        return (String) comboBoxRotorType.getSelectedItem();
    }

    public void setTextTurnover(String message){
        textTurnover.setText(message);
    }
    public JComboBox getComboBoxRotorType() {
        return comboBoxRotorType;
    }
    public int getSliderPos(){
        return positionSlider.getValue();
    }
    public void setRotorIcon(int comboIndex){
        switch (comboIndex) {
            case 1 -> labelImage.setIcon(rotor1Icon);
            case 2 -> labelImage.setIcon(rotor2Icon);
            case 3 -> labelImage.setIcon(rotor3Icon);
            case 4 -> labelImage.setIcon(rotor4Icon);
            case 5 -> labelImage.setIcon(rotor5Icon);
            case 6 -> labelImage.setIcon(rotor6Icon);
            case 7 -> labelImage.setIcon(rotor7Icon);
            default -> labelImage.setIcon(rotor8Icon);
        }
    }
    public void rotorInstructions(){
        JDialog dia = new JDialog(rotorFrame,"Rotor Instructions");
        JLabel textInstructions = new JLabel("Each rotor contains an outside and inside ring of letters with internal wire connections linking them, " +
                "again substituting one value for another. After each input, the first rotor also referred to as the “fast rotor” will rotate one position. " +
                "Each rotor has a ‘turnover’ position at which the next rotation it makes will also affect its neighbouring rotor." +
                " The position of the rotor was denoted with a letter on the outside curve and could be seen by the operator.");
        dia.add(textInstructions);
        dia.setSize(200,200);
        dia.setVisible(true);
    }
    public void rotorInfo() throws BadLocationException {
        JDialog dia = new JDialog(rotorFrame,"Background Info");
        StyleContext con = new StyleContext();
        DefaultStyledDocument doc = new DefaultStyledDocument(con);
        Style defaultStyle = con.addStyle("Default",null);
        JTextPane textInstructions = new JTextPane(doc);
        textInstructions.setEditable(false);
        dia.add(textInstructions);
        dia.setSize(400,200);
        dia.setVisible(true);
        defaultStyle.addAttribute(StyleConstants.Foreground, new Color(0,0,0));
        defaultStyle.addAttribute(StyleConstants.FontSize, 14);
        defaultStyle.addAttribute(StyleConstants.Family,"Helvetica");
        String msg = "Each rotor contains an outside and inside ring of letters with internal wire connections linking them, " +
                "again substituting one value for another. After each input, the first rotor also referred to as the 'fast rotor' will rotate one position." +
                "Each rotor has a ‘turnover’ position at which the next rotation it makes will also affect its neighbouring rotor. " +
                "The position of the rotor was denoted with a letter on the outside curve and could be seen by the operator.";
        doc.insertString(0,msg,defaultStyle);
        textInstructions.setBounds(5,20,350,150);
    }
}
